.486

.model flat,stdcall
option casemap:none

include c:\masm32\include\windows.inc

include c:\masm32\include\user32.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\comdlg32.inc
include c:\MASM32\INCLUDE\shell32.inc
include c:\masm32\include\masm32.inc
include c:\masm32\include\comctl32.inc
include c:\masm32\include\fpu.inc
include c:\masm32\include\debug.inc

;--->

includelib c:\masm32\lib\comctl32.lib
includelib c:\masm32\lib\masm32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\comdlg32.lib
includelib c:\masm32\lib\shell32.lib
includelib c:\masm32\lib\fpu.lib
includelib c:\masm32\lib\debug.lib


IDD_DIALOG1 	equ 101
ID_CALC     	equ 1000
ID_EXIT     	equ 1001
ID_ABOUT    	equ 1002
IDC_TARGET  	equ 1003
ID_BROWSE  		equ 1004
IDC_ENT     	equ 1005
IDC_Prog    	equ 1006
IDC_RES     	equ 1007

DlgProc 			PROTO :DWORD,:DWORD,:DWORD,:DWORD
SelFile				PROTO :DWORD
Calcu			 		PROTO :DWORD

.data

ofn   			OPENFILENAME <>

FilterStr 	db "All files",0,"*.*",0,0,0
PlsSelFile	db "[select or drag a file]",0

stAlloc			db "Allocating memory and counting probability...",0
stCalcu			db "Parsing probability and calculating entropy...",0
szDoneC			db "Calculation complete. File is probably compressed.",0 
szDoneNC		db "Calculation complete. File is probably not compressed.",0 

ErrNoFile		db "ERROR: Can't open file!",0
ErrNoAlloc	db "ERROR: Can't allocate 512 KB of memory!",0
ErrCalc			db "ERROR: Unknown error occured while calculating!",0

szAbText		db "- EntropyCalc v0.1 (c)oded by Ghirai - Compiled in November 2004 -",13,10,13,10
						db "Email: ghirai@ghirai.com",13,10
						db "Web: http://ghirai.com",13,10,13,10
						db "Fore best results interpretation, check the documentation.",0

szAbtCap		db ".:: About EntropyCalc",0


.data?

Nums			dword 0FFh dup(?)

Probs			tbyte 0FFh dup (?)
Entrops		tbyte 0FFh dup (?)

Tot				tbyte ?

wStat			word ?

hFile			dword ?
fSize			dword ?
pMem			dword ?
bRead			dword ?

mprms			MSGBOXPARAMS <?>
hInstance	dword ?
IzCl			byte ?
CLine			dword ?

buffer 		db 512 dup(?)

.code

Calcu proc hDlg:dword
LOCAL Buf[256]:byte


mov eax,sizeof dword
imul eax,0ffh
invoke RtlZeroMemory,addr Nums,eax

mov eax,sizeof tbyte
imul eax,0ffh
invoke RtlZeroMemory,addr Probs,eax

invoke CreateFile,addr buffer,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
.if eax==INVALID_HANDLE_VALUE
	invoke SetDlgItemText,hDlg,IDC_RES,addr ErrNoFile
	ret
.endif

mov hFile,eax

invoke GetFileSize,eax,0
mov fSize,eax

invoke SetDlgItemText,hDlg,IDC_RES,addr stAlloc

invoke VirtualAlloc,0,524288,MEM_COMMIT,PAGE_READWRITE
.if eax==0
	invoke SetDlgItemText,hDlg,IDC_RES,addr ErrNoAlloc
	jmp Bail
.endif

mov pMem,eax

xor esi,esi
lea edi,Nums

.while esi<fSize
	
	invoke ReadFile,hFile,pMem,524288,addr bRead,0
	add esi,bRead

	xor ecx,ecx
	xor eax,eax
	mov ebx,pMem
	
	.while ecx<bRead
	 		
		mov al,byte ptr[ebx+ecx]
		add dword ptr[edi+4*eax],1
		add ecx,1
	 	 	
	.endw 
	
.endw 

;---- ok ----;

invoke CloseHandle,hFile
invoke VirtualFree,pMem,524288,MEM_DECOMMIT
invoke SetDlgItemText,hDlg,IDC_RES,addr stCalcu

xor esi,esi
lea ecx,Probs

.while esi<0FFh
	
	mov ebx,ecx
	mov eax,esi
	imul eax,sizeof tbyte
	add ebx,eax
		
	mov eax,dword ptr[edi+4*esi]
	
	.if eax!=0
		
		invoke FpuDiv,eax,fSize,ebx,SRC1_DIMM or SRC2_DIMM
		.if eax==0
			invoke SetDlgItemText,hDlg,IDC_RES,addr ErrCalc
			.break
		.endif
	
	.endif
	
	add esi,1
	
.endw


;---- ok ----;


xor esi,esi
xor ebx,ebx

lea ecx,Probs

.while esi<09F6h
	
	.if dword ptr[edi+4*ebx]!=0
	
		fld1
		fld tbyte ptr[ecx+esi] 
		fyl2x
		fchs
		fst tbyte ptr[ecx+esi]
		fwait
	
	.endif
	
	add esi,10
	add ebx,1
	
.endw

lea esi,Probs
lea edi,Nums
lea edx,Entrops


invoke FpuFLtoA,edi,17,addr Buf,SRC1_REAL or SRC2_DIMM
PrintString Buf



xor ecx,ecx
xor ebx,ebx

.while ecx<09F6h

	.if dword ptr[edi+4*ebx]!=0
	
		fld tbyte ptr[esi+ecx]
		fld dword ptr[edi+4*ebx]
		fmulp st(1),st
		fstp tbyte ptr[edx+ecx]
		fwait
	.endif
	
	add ecx,10
	add ebx,1
	
.endw

xor ecx,ecx
fldz

.while ecx<09F6h
	
	fld tbyte ptr[edx+ecx]
	faddp st(1),st
	add ecx,10
.endw



invoke FpuFLtoA,0,17,addr Buf,SRC1_FPU or SRC2_DIMM

invoke SetDlgItemText,hDlg,IDC_ENT,addr Buf
	
;invoke SetDlgItemText,hDlg,IDC_RES,addr szDone






ret

Bail:

invoke CloseHandle,hFile
invoke VirtualFree,pMem,524288,MEM_DECOMMIT

ret
Calcu endp

SelFile proc hDlg:DWORD
	
mov ofn.lStructSize,SIZEOF ofn
mov ofn.lpstrFilter, OFFSET FilterStr
mov ofn.lpstrFile, OFFSET buffer
mov ofn.nMaxFile,512
mov ofn.Flags,OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
	

invoke GetOpenFileName,addr ofn
.if eax==1
	invoke SetDlgItemText,hDlg,IDC_TARGET,addr buffer
.endif

ret
SelFile endp

DlgProc proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD		

.if uMsg==WM_CLOSE
	
	invoke EndDialog,hDlg,0
	
.elseif uMsg==WM_INITDIALOG
	
	invoke SetDlgItemText,hDlg,IDC_TARGET,addr PlsSelFile

	;.if IzCl==1
	;	invoke SetDlgItemText,hDlg,IDC_FILE,addr EDataS
	;	invoke Calcu,hDlg
	;.endif

.elseif uMsg == WM_DROPFILES
          
	invoke DragQueryFile,wParam,0,addr buffer,512
  invoke SetDlgItemText,hDlg,IDC_TARGET,addr buffer
  ;invoke SetDlgItemText,hDlg,IDC_MD5,0
        	
.elseif uMsg==WM_COMMAND
	mov eax,wParam
	.if lParam!=0
		mov edx,wParam
		shr edx,16
		.if dx==BN_CLICKED
			
			;browse button
			.if ax==ID_BROWSE
			
				invoke SelFile,hDlg
			
			.elseif ax==ID_CALC
					invoke Calcu,hDlg
				
			.elseif ax==ID_ABOUT
				
				invoke RtlZeroMemory,addr mprms,sizeof mprms
				
				mov mprms.cbSize,sizeof mprms

				push hDlg
				pop mprms.hwndOwner
				push hInstance
				pop mprms.hInstance
				
				mov mprms.lpszText,offset szAbText
				mov mprms.lpszCaption,offset szAbtCap
				mov mprms.dwStyle,MB_USERICON+MB_OK
				mov mprms.lpszIcon,200
				
				invoke MessageBoxIndirect,addr mprms
				
			.else	;exit button
				invoke SendMessage,hDlg,WM_CLOSE,0,0
			.endif
		
		.endif
	.endif
		
.else
	xor eax,eax
	ret
.endif
	
xor eax,eax
add eax,1
ret
DlgProc endp


;--------------------------------------------------------------------------------


_ep:

invoke InitCommonControls

comment #
invoke GetCommandLine
mov CLine,eax

invoke GetModuleFileName,0,addr ffset,255

invoke lstrlen,CLine
mov edi,eax

invoke lstrlen,addr ffset
add eax,3

invoke szMid,CLine,addr EDataS,eax,edi

invoke lstrlen,addr EDataS
.if eax>1
	invoke lstrcpy,addr buffer,addr EDataS
	mov IzCl,1	
.endif

#

invoke GetModuleHandle,0
mov hInstance,eax
invoke DialogBoxParam,eax,IDD_DIALOG1,0,addr DlgProc,0
invoke ExitProcess,0

end _ep